<?php

function fastgallery_block_render_callback($attributes) {
	$fg_thumbs_lightbox = $attributes['thumb_lightbox_size'];
	$custom_url_target = $attributes['cu_target'];
	$itemtag 	= 'div'; 
	$icontag 	= 'div';
	$captiontag = 'div';	

	if( $attributes['custom_responsive'] == 'fg_responsive') {
		$fg_responsive_class = 'fg_responsive';
	} else {
		$fg_responsive_class = 'fg_smartphone_p_col-'.$attributes['smartphone_p_columns'].' fg_smartphone_l_col-'.$attributes['smartphone_l_columns'].' fg_tablet_p_col-'.$attributes['tablet_p_columns'].' fg_tablet_l_col-'.$attributes['tablet_l_columns'].' fg_desktop_medium_col-'.$attributes['desktop_medium_columns'].' fg_desktop_small_col-'.$attributes['desktop_small_columns'].'';
	}


	
	$css_style_to_append = '.fastgallery-'.$attributes['blockId'].', .fastgallery .fg-gallery-caption { --fgBackgroundColor: '.$attributes['backgroundColor'].'; --fgTextColor: '.$attributes['textColor'].'; --fgPadding: '.$attributes['spacing'].'px; --fgPaddingPx: var(--fgPadding); --fgFontSize: '.$attributes['fontSize'].'px; --fgIconFontSize: '.$attributes['iconFontSize'].'px; }';
	
	if($attributes['lightboxType'] == 'prettyphoto') {
		$data_attr = 'data-pp-animation-speed="'.$attributes['pp_animation_speed'].'" 
		data-pp-time="'.$attributes['pp_time'].'"
		data-pp-autoplay="'.$attributes['pp_autoplay'].'"
		data-pp-title="'.$attributes['pp_title'].'"
		data-pp-social="'.$attributes['pp_social'].'"
		';
	} else {
		$data_attr = '';
	}
	
	$return = '<div id="fastgallery-'.$attributes['blockId'].'"
				class="gallery fastgallery-'.$attributes['blockId'].' 
				fgg-'.$attributes['lightboxType'].' 
				gallery-columns-'.$attributes['columns'].' 
				gallery-size-'.$attributes['type'].' fastgallery brick-masonry 
				'.$attributes['type'].'
				'.$fg_responsive_class.'
				'.$attributes['layoutStyle'].' 
				'.$attributes['oneThumb'].' 
				'.$attributes['overImage'].' 
				adt-custom-js"
				data-custom-css="'.$css_style_to_append.'"
				'.$data_attr.'>';
	$return .= '<div class="fastgallery-container">';

				foreach ( $attributes['images'] as $image ) {
					$id = $image['id'];
					$_post = get_post( $id );
					$image_attributes = wp_get_attachment_image_src( $_post->ID, $fg_thumbs_lightbox );
					
					if($attributes['lightboxType'] == 'custom_url') {					
						$url = get_post_meta( $id, '_custom_url', true );						
					} else {
						$url = $image_attributes[0];
					}
					
					$attachment_caption_array = get_post( $_post->ID );
					$attachment_caption	= $attachment_caption_array->post_excerpt;
					
					if($attributes['type'] == 'fg-normal') {
						$link_text = wp_get_attachment_image( $id , 'fggrid');
					} else {
						$link_text = wp_get_attachment_image( $id , 'fgmasonry');
					}
					
					
					if($attributes['lightboxType'] == 'custom_url') {
						$image_output = "<div class='fg_zoom'>$link_text<a href='$url' target='$custom_url_target'><span class='fg-zoom-icon ".$attributes['icon']."'></span></a></div>";					
					} else {
						$image_output = "<div class='fg_zoom'>$link_text<a href='$url' title=\"$attachment_caption\" data-rel-fg='prettyPhoto[album-1]' class='fg_magnificPopup'><span class='fg-zoom-icon ".$attributes['icon']."'></span><span style='display:none'>$link_text</span></a></div>";							
					}
					$return .= "<{$itemtag} class='fg-gallery-item'>";
					// CHECK CAPTION
					$caption_check = '';
					if($attributes['caption'] == 'off' || empty($attachment_caption)) {
						$caption_check = 'no-caption';
					}
					// END CHECK CAPTION
					
					$return .= "
					<{$icontag} class='fastgallery-gallery-icon $caption_check'>$image_output";
					if ($attributes['caption'] == 'on' && !empty($attachment_caption)) {
					$return .= "
						<{$captiontag} class='fg-wp-caption-text fg-gallery-caption'><div class='caption-container'>
						" . $attachment_caption . "
						</div></{$captiontag}>";
					}
					$return .= "</{$icontag}></{$itemtag}>";
					}
					$return .= "
					</div>\n";
					
					if($attributes['oneThumb'] == 'off') {
						$return .= '<div class="fg_clear"></div>';
					}
						
	$return .= '</div><div class="fg_clear"></div>';
	
	return $return;
}