jQuery(document).ready(function($){
	"use strict";
	
	$('.fastgallery.brick-masonry.fg-masonry .fastgallery-container').each( function() {
		var $container = $(this).masonry({
			columnWidth: 1
		});
		$container.imagesLoaded( function() {
			$container.masonry();
		});		
	});	

	$(".adt-custom-js").each(function( index ) {
		var custom_css = "<style id='fgg-custom-css'>"+$(this).attr("data-custom-css")+"</style>";
		$( custom_css ).appendTo( "head" );
	});	

	$('.fg-gallery-caption').on('mouseover mouseout', function(event) {
		if (event.type == 'mouseover') {
			$(this).parents('.fastgallery-gallery-icon').find('.fg_zoom').addClass('fg_over');
			return false;
		} else {
			$(this).parents('.fastgallery-gallery-icon').find('.fg_zoom').removeClass('fg_over');
			return false;				
		}			
	});	

    $(".fgg-prettyphoto").each(function( index ) {
		var fgg_pp_animation_speed = $(this).data("pp-animation-speed");
		var fgg_pp_time = $(this).data("pp-time");
		var fgg_pp_autoplay = $(this).data("pp-autoplay");
		var fgg_pp_title = $(this).data("pp-title");
		var fgg_pp_social = $(this).data("pp-social");
		
		var queryString = ".fgg-prettyphoto:nth(" + index + ") a[data-rel-fg^='prettyPhoto']";
		if(fgg_pp_social == false) {
			$(queryString).prettyPhoto({
					animation_speed: fgg_pp_animation_speed,
					slideshow: fgg_pp_time,
					autoplay_slideshow: fgg_pp_autoplay,
					show_title: fgg_pp_title,
					social_tools: false
			});
		} else {
			$(queryString).prettyPhoto({
					animation_speed: fgg_pp_animation_speed,
					slideshow: fgg_pp_time,
					autoplay_slideshow: fgg_pp_autoplay,
					show_title: fgg_pp_title,
			});						
		}
	});
	
	$(".fgg-magnific-popup").each(function( index ) {
		$(this).magnificPopup({
			delegate: 'a',
			type: 'image',					
			gallery:{ enabled:true }					
		});				
	});	
				
});